## auto-multiple-choice 1.2.1

=== Makefile ===
#
# Copyright (C) 2008-2012 Alexis Bienvenue <paamc@passoire.fr>
#
# This file is part of Auto-Multiple-Choice
#
# Auto-Multiple-Choice is free software: you can redistribute it
# and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# Auto-Multiple-Choice is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Auto-Multiple-Choice.  If not, see
# <http://www.gnu.org/licenses/>.

# Loads separate configuration file

ifeq ($(AMCCONF),)
AMCCONFFILE ?= Makefile.conf
else
AMCCONFFILE = Makefile-$(AMCCONF).conf
endif

SUB_MAKEFILES=$(wildcard Makefile.versions $(AMCCONFFILE))

include $(SUB_MAKEFILES)

PACKAGE_DEB_DV=1
PERLPATH ?= /usr/bin/perl

# DATE/TIME to be substituted

DATE_RPMCHL:=$(shell LC_TIME=en_US date +"%a %b %e %Y")
DATE_DEBCHL:=$(shell LANG=C date "+%a, %d %b %Y %H:%M:%S %z")

# list variables to be substituted in *.in files

SUBST_VARS:=$(shell grep -h '=' $(SUB_MAKEFILES) | perl -pe 's/\#.*//;s/\??\+?=.*//;' ) PACKAGE_DEB_DV PERLPATH DATE_DEBCHL DATE_RPMCHL

# Some default values

GCC ?= gcc
GCC_PP ?= gcc
CFLAGS ?= -O2
CXXFLAGS ?= -O2

# try to find right names for OpenCV libs 

ifeq ($(GCC_OPENCV_LIBS),auto)
ifeq ($(shell echo 'main(){}' | gcc -xc -lopencv_core - -o /dev/null 2>/dev/null && echo "OK"),OK)
  GCC_OPENCV_LIBS:=-lopencv_core -lopencv_highgui -lopencv_imgproc
else
  GCC_OPENCV_LIBS:=-lcv -lhighgui -lcxcore
endif
endif

#

SHELL=/bin/sh

DESTDIR=

# AMC components to build

BINARIES ?= AMC-traitement-image AMC-detect

MODS=AMC-*.pl
GLADE_FROMIN:=$(basename $(wildcard AMC-gui-*.glade.in))
GLADE_SIMPLE:=$(filter-out $(GLADE_FROMIN),$(wildcard AMC-gui-*.glade))
GLADE=$(GLADE_FROMIN) $(GLADE_SIMPLE)
STY=doc/sty/automultiplechoice.sty
DTX=doc/sty/automultiplechoice.dtx
MOS=$(wildcard I18N/lang/*.mo)
LANGS=$(notdir $(basename $(MOS)))
SUBMODS=$(notdir $(shell ls doc/modeles))

DOC_XML_IN=$(wildcard doc/auto-multiple-choice.*.in.xml)

# list *.in files for @/VAR/@ substitution

FROM_IN=auto-multiple-choice auto-multiple-choice.desktop $(GLADE_FROMIN) AMC-gui.pl AMC-latex-link.pl AMC-perl/AMC/Basic.pm doc/doc-xhtml-site.fr.xsl doc/doc-xhtml-site.en.xsl doc/doc-xhtml.xsl $(DOC_XML_IN:.in.xml=.xml) $(DTX)

# Is this a precomp tarball? If so, the PRECOMP file is present.

PRECOMP_FLAG_FILE=PRECOMP
PRECOMP_ARCHIVE:=$(wildcard $(PRECOMP_FLAG_FILE))

MAIN_LOGO=icons/auto-multiple-choice

# Sets user and group flags for install command

ifeq ($(INSTALL_USER),)
else
USER_GROUP = -o $(INSTALL_USER)
endif
ifeq ($(INSTALL_GROUP),)
else
USER_GROUP += -g $(INSTALL_GROUP)
endif

# Target switch (precomp archive or not)

ifeq ($(PRECOMP_ARCHIVE),)
all: $(FROM_IN) $(BINARIES) $(MAIN_LOGO).xpm doc I18N ;
else
all: all_precomp ;
endif

all_precomp: $(FROM_IN) $(BINARIES) ;

MAJ: $(FROM_IN) ;

# Binaries

AMC-traitement-image: AMC-traitement-image.c Makefile
	$(GCC) -o $@ $< $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(GCC_NETPBM)

AMC-detect: AMC-detect.cc Makefile
	$(GCC_PP) -o $@ $< $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) $(CXXLDFLAGS) -lstdc++ -lm $(GCC_OPENCV) $(GCC_OPENCV_LIBS)

# substitution in *.in files

%.xml: %.in.xml
	perl -p $(foreach varname,$(SUBST_VARS), -e 's|@/$(varname)/@|$($(varname))|g;' ) -e 's+/usr/share/xml/docbook/schema/dtd/4.5/docbookx.dtd+$(DOCBOOK_DTD)+g;' $< > $@

%: %.in $(SUB_MAKEFILES)
	perl -p $(foreach varname,$(SUBST_VARS), -e 's|@/$(varname)/@|$($(varname))|g;' ) $< > $@

# some components

doc:
	$(MAKE) -C doc
	$(MAKE) -C doc/sty

I18N:
	$(MAKE) -C I18N

sync:
	$(MAKE) -C download-area all

# Individual rules

%.ps: %.dvi
	dvips $< -o $@

%.ppm: %.ps
	convert -density 300 $< $*-%03d.ppm

%.png: %.svg
	rsvg-convert -w 32 -h 32 $< -o $@

%.xpm: %.png
	pngtopnm $< | ppmtoxpm > $@

# CLEAN

clean_IN: FORCE
	rm -rf debian/auto-multiple-choice
	rm -f $(FROM_IN)

clean: clean_IN FORCE
	rm -f $(BINARIES) $(MAIN_LOGO).xpm
	rm -f auto-multiple-choice.spec
	$(MAKE) -C doc/sty clean
	$(MAKE) -C doc clean
	$(MAKE) -C I18N clean

# INSTALL

install_lang_%: FORCE
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(LOCALEDIR)/$*/LC_MESSAGES
	install    -m 0644 $(USER_GROUP) I18N/lang/$*.mo $(DESTDIR)/$(LOCALEDIR)/$*/LC_MESSAGES/auto-multiple-choice.mo

install_lang: $(addprefix install_lang_,$(LANGS)) ;

install_models_%: FORCE
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(MODELSDIR)/$*
	install    -m 0644 $(USER_GROUP) doc/modeles/$*/*.tgz $(DESTDIR)/$(MODELSDIR)/$*
	install    -m 0644 $(USER_GROUP) doc/modeles/$*/*.xml $(DESTDIR)/$(MODELSDIR)/$*

install_models: $(addprefix install_models_,$(SUBMODS)) ;

install: install_lang install_models FORCE
ifneq ($(SYSTEM_TYPE),deb) # with debian, done with dh_installmime
ifneq ($(SHARED_MIMEINFO_DIR),)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(SHARED_MIMEINFO_DIR)
	install    -m 0644 $(USER_GROUP) interfaces/auto-multiple-choice.xml $(DESTDIR)/$(SHARED_MIMEINFO_DIR)
endif
endif
ifneq ($(LANG_GTKSOURCEVIEW_DIR),)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(LANG_GTKSOURCEVIEW_DIR)
	install    -m 0644 $(USER_GROUP) interfaces/amc-txt.lang $(DESTDIR)/$(LANG_GTKSOURCEVIEW_DIR)
endif
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(MODSDIR)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(MODSDIR)/perl
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(MODSDIR)/exec
	install    -m 0755 $(USER_GROUP) $(MODS) $(DESTDIR)/$(MODSDIR)/perl
	install    -m 0755 $(USER_GROUP) $(BINARIES) $(DESTDIR)/$(MODSDIR)/exec
	install    -m 0644 $(USER_GROUP) $(GLADE) $(DESTDIR)/$(MODSDIR)/perl
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(TEXDIR)
	install    -m 0644 $(USER_GROUP) $(STY) $(DESTDIR)/$(TEXDIR)
ifneq ($(TEXDOCDIR),)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(TEXDOCDIR)
	install    -m 0644 $(USER_GROUP) doc/sty/*.pdf doc/sty/*.tex $(DESTDIR)/$(TEXDOCDIR)
endif
ifneq ($(DESKTOPDIR),)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(DESKTOPDIR)
	install    -m 0644 $(USER_GROUP) -T auto-multiple-choice.desktop $(DESTDIR)/$(DESKTOPDIR)/auto-multiple-choice.desktop
endif
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(BINDIR)
	install    -m 0755 $(USER_GROUP) auto-multiple-choice $(DESTDIR)/$(BINDIR)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(ICONSDIR)
	install    -m 0644 $(USER_GROUP) icons/*.svg $(DESTDIR)/$(ICONSDIR)
ifneq ($(PIXDIR),)
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PIXDIR)
	install    -m 0644 $(USER_GROUP) -T $(MAIN_LOGO).xpm $(DESTDIR)/$(PIXDIR)/auto-multiple-choice.xpm
endif
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Export
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Export/register
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Filter
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Filter/register
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/DataModule
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Gui
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/*.pm $(DESTDIR)/$(PERLDIR)/AMC
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Export/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Export
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Export/register/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Export/register
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Filter/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Filter
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Filter/register/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Filter/register
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/DataModule/*.pm $(DESTDIR)/$(PERLDIR)/AMC/DataModule
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Gui/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Gui
	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Gui/*.glade $(DESTDIR)/$(PERLDIR)/AMC/Gui
ifneq ($(SYSTEM_TYPE),deb) # with debian, done with dh_install{doc,man}
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(DOCDIR)
	install    -m 0644 $(USER_GROUP) $(wildcard doc/auto-multiple-choice.??.xml doc/auto-multiple-choice.??.pdf) $(DESTDIR)/$(DOCDIR)
	cp -r doc/html $(DESTDIR)/$(DOCDIR)
ifeq ($(INSTALL_USER),)
else
	chown -hR $(INSTALL_USER) $(DESTDIR)/$(DOCDIR)
endif
ifeq ($(INSTALL_GROUP),)
else
	chgrp -hR $(INSTALL_GROUP) $(DESTDIR)/$(DOCDIR)
endif
	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(MAN1DIR)
	install    -m 0644 $(USER_GROUP) doc/*.1 $(DESTDIR)/$(MAN1DIR)
endif

# Test

manual-test:
	$(MAKE) -C tests test

##############################################################################
# Following lines are only helpfull for source tarball and package building
# These targets run only with source from svn checkout
##############################################################################

LOCALDIR=$(shell pwd)

global: FORCE
	$(MAKE) -C I18N global LOCALEDIR=$(LOCALEDIR) LOCALDIR=$(LOCALDIR)
	-sudo rm /usr/share/perl5/AMC $(ICONSDIR) /usr/share/doc/auto-multiple-choice /usr/share/doc/auto-multiple-choice-doc $(LOCALEDIR)/fr/LC_MESSAGES/auto-multiple-choice.mo $(DESKTOPDIR)/auto-multiple-choice.desktop $(MODELSDIR) /usr/bin/auto-multiple-choice $(TEXDIR)/automultiplechoice.sty
	-sudo rm -r /usr/lib/AMC

local: global
	$(MAKE) -C I18N local LOCALEDIR=$(LOCALEDIR) LOCALDIR=$(LOCALDIR)
	test -d /usr/lib/AMC || sudo mkdir -p /usr/lib/AMC
	test -d /usr/lib/AMC/perl || sudo mkdir -p /usr/lib/AMC/perl
	test -d /usr/lib/AMC/exec || sudo mkdir -p /usr/lib/AMC/exec
	test -d /usr/share/auto-multiple-choice  || sudo mkdir -p /usr/share/auto-multiple-choice
	test -d $(TEXDIR) || sudo mkdir $(TEXDIR)
	sudo ln -s $(LOCALDIR)/AMC-perl/AMC /usr/share/perl5/AMC
	sudo ln -s $(LOCALDIR)/AMC-traitement-image /usr/lib/AMC/exec/AMC-traitement-image
	sudo ln -s $(LOCALDIR)/AMC-detect /usr/lib/AMC/exec/AMC-detect
	sudo ln -s $(LOCALDIR)/AMC-*.pl $(LOCALDIR)/AMC-*.glade /usr/lib/AMC/perl
	sudo ln -s $(LOCALDIR)/auto-multiple-choice /usr/bin
	sudo ln -s $(LOCALDIR)/icons $(ICONSDIR)
	sudo ln -s $(LOCALDIR)/doc /usr/share/doc/auto-multiple-choice-doc
	sudo ln -s $(LOCALDIR)/auto-multiple-choice.desktop $(DESKTOPDIR)/auto-multiple-choice.desktop
	sudo ln -s $(LOCALDIR)/doc/modeles $(MODELSDIR)
	sudo ln -s $(LOCALDIR)/$(STY) $(TEXDIR)/automultiplechoice.sty

ifdef DEBSIGN_KEY
DEBSIGN=-k$(DEBSIGN_KEY)
else
DEBSIGN=-us -uc
endif

BUILDOPTS=-I.svn -Idownload_area -Ilocal $(DEBSIGN)

TMP_DIR=/tmp
SOURCE_DIR=auto-multiple-choice-$(PACKAGE_V_DEB)
TMP_SOURCE_DIR=$(TMP_DIR)/$(SOURCE_DIR)

SRC_EXCL=--exclude debian '--exclude=*~' 

version_files:
	perl local/versions.pl
	$(MAKE) auto-multiple-choice.spec

tmp_copy:
	rm -rf $(TMP_SOURCE_DIR)
	mkdir $(TMP_SOURCE_DIR)
	rsync -aC --exclude '*~' --exclude download_area --exclude local . $(TMP_SOURCE_DIR)
	$(MAKE) -C $(TMP_SOURCE_DIR) clean

portable_vok:
	$(eval TMP_PORTABLE:=$(shell mktemp -d /tmp/portable.XXXXXXXXXX))
	$(MAKE) tmp_copy
	make AMCCONF=portable INSTREP=$(TMP_PORTABLE)/AMC -C $(TMP_SOURCE_DIR)
	make AMCCONF=portable INSTREP=$(TMP_PORTABLE)/AMC -C $(TMP_SOURCE_DIR) install
	cd $(TMP_PORTABLE) ; tar cvzf /tmp/auto-multiple-choice_$(PACKAGE_V_DEB)_portable.tar.gz $(SRC_EXCL) AMC
	rm -rf $(TMP_PORTABLE)

sources_vok:
	$(MAKE) tmp_copy
	cd /tmp ; tar cvzf auto-multiple-choice_$(PACKAGE_V_DEB)_sources.tar.gz $(SRC_EXCL) $(SOURCE_DIR)
	$(MAKE) -C $(TMP_SOURCE_DIR) MAJ
	$(MAKE) -C $(TMP_SOURCE_DIR) $(MAIN_LOGO).xpm I18N doc
	$(MAKE) -C $(TMP_SOURCE_DIR) clean_IN
	$(MAKE) -C $(TMP_SOURCE_DIR) auto-multiple-choice.spec
	touch $(TMP_SOURCE_DIR)/$(PRECOMP_FLAG_FILE)
	test -d ../precomp_external && cp -r ../precomp_external/* $(TMP_SOURCE_DIR)
	cd /tmp ; tar cvzf auto-multiple-choice_$(PACKAGE_V_DEB)_precomp.tar.gz $(SRC_EXCL) $(SOURCE_DIR)

tmp_deb:
	$(MAKE) local/deb-auto-changelog
	$(MAKE) tmp_copy
	cp local/deb-auto-changelog $(TMP_SOURCE_DIR)/debian/changelog

debsrc_vok: tmp_deb

=== I18N/Makefile ===
#
# Copyright (C) 2010-2012 Alexis Bienvenue <paamc@passoire.fr>
#
# This file is part of Auto-Multiple-Choice
#
# Auto-Multiple-Choice is free software: you can redistribute it
# and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# Auto-Multiple-Choice is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Auto-Multiple-Choice.  If not, see
# <http://www.gnu.org/licenses/>.

SHELL=/bin/sh

DOMAIN=auto-multiple-choice

XGETTO=

AMC=..

PERL=$(AMC)/*.pl $(AMC)/AMC-perl/AMC/*.pm $(AMC)/AMC-perl/AMC/**/*.pm $(AMC)/AMC-perl/AMC/**/**/*.pm 

GLADE=$(AMC)/AMC-*.glade $(AMC)/AMC-perl/AMC/**/*.glade

POS=$(wildcard lang/*.po)
MOS=$(POS:.po=.mo)
LANGS=$(basename $(notdir $(POS)))

all: $(MOS)

clean: FORCE
	rm -f $(MOS)
	rm -f *.bpot
	rm -f *.po

%.mo: %.po
	msgfmt $< -o $@

###############################################################
# The following targets are only for packaging :
# not used for building or installing

po-clean.pl: po-clean.pl.in ../Makefile.versions
	$(MAKE) -C .. I18N/po-clean.pl

%.pot: %.bpot po-clean.pl
	perl po-clean.pl $< $@

$(DOMAIN).bpot: $(PERL) $(GLADE)
	xgettext $(XGETTO) --from-code=UTF-8 --add-comments=TRANSLATORS: $(PERL) -k__ -k__p -k -o $@
	xgettext $(XGETTO) -j $(GLADE) -o $@

list:
	grep -lr __ $(AMC) |grep '\.\(pl\|pm\)$$' | grep -v 'debian' ; ls $(GLADE)

%.merge: $(DOMAIN).pot
	msgmerge --no-wrap -U lang/$*.po $(DOMAIN).pot

merge: $(addsuffix .merge,$(LANGS)) ;

%.local: FORCE
	test -d $(LOCALEDIR)/$*/LC_MESSAGES || sudo mkdir -p $(LOCALEDIR)/$*/LC_MESSAGES
	sudo ln -s $(LOCALDIR)/I18N/lang/$*.mo $(LOCALEDIR)/$*/LC_MESSAGES/auto-multiple-choice.mo

local: $(foreach l,$(LANGS),$(l).local) ;

%.global: FORCE
	-sudo rm $(LOCALEDIR)/$*/LC_MESSAGES/auto-multiple-choice.mo

global: $(foreach l,$(LANGS),$(l).global) ;

###############################################################

FORCE: ;

.PHONY: all clean list merge FORCE

.INTERMEDIATE: $(DOMAIN).bpot

=== doc/Makefile ===
#
# Copyright (C) 2008-2010,2012 Alexis Bienvenue <paamc@passoire.fr>
#
# This file is part of Auto-Multiple-Choice
#
# Auto-Multiple-Choice is free software: you can redistribute it
# and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# Auto-Multiple-Choice is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Auto-Multiple-Choice.  If not, see
# <http://www.gnu.org/licenses/>.

SHELL=/bin/sh

include ../Makefile.conf

DOCBOOKS=$(filter-out $(wildcard *.in.xml),$(wildcard *.xml))

IMAGES=$(addprefix html/images/,$(notdir $(wildcard img_src/*.svg))) $(addprefix html/images/callouts/,$(notdir $(wildcard img_src/callouts/*.svg)))

MODELS=$(wildcard modeles/*/*.d)

all: $(filter-out %.ja.pdf,$(DOCBOOKS:.xml=.pdf)) $(DOCBOOKS:.xml=.x) $(IMAGES:.svg=.png) $(MODELS:.d=.tgz) html/index.html;

images: $(IMAGES:.svg=.png)

clean:
	rm -f $(foreach ext,1 aux cb cb2 glo idx log out toc tex html pdf ext man,*.$(ext))
	rm -f modeles/*.tgz
	rm -f modeles/**/*.tgz
	rm -f html/auto-multiple-choice.**/*.html
	rm -f html/images/callouts/*.png html/images/*.png
	rm -f *~

html/images/callouts/%.png: img_src/callouts/%.svg
	rsvg-convert -w 12 -h 12 $< -o $@

html/images/%.png: img_src/%.svg
	rsvg-convert -w 24 -h 24 $< -o $@

html/index.html: FORCE
	./index.pl $(DOCBOOKS:.xml=) > $@

%.tex: %.xml
	dblatex -t tex --xslt-opts="--nonet" --xslt-opts="--catalogs" $(DBLATEX_OPT) $< -o $@
	perl addlink.pl $@

%.pdf: %.tex
	case $< in \
	  *.ja.tex) platex $<; platex $<; dvipdf $*.dvi ;; \
	  *.tex) pdflatex $<; pdflatex $< ;; \
	esac
	rm -f $(foreach ext,aux cb cb2 glo idx log out toc,$*.$(ext))

%.x: %.ext %.man %.html ;

%.ext: %.xml
	perl extrait-fichiers.pl --liste $@ $<

%.man: %.xml
	xsltproc --nonet --catalogs --param man.charmap.use.subset "0" --param make.year.ranges "1" --param make.single.year.ranges "1" --param man.output.lang.in.name.enabled "1" $(DOCBOOK_MAN_XSL) $<
	date > $@


%.html: %.xml doc-xhtml.xsl
	rm -f html/$*/*.html
	xsltproc --nonet --catalogs --stringparam base.dir html/$*/ doc-xhtml.xsl $<
	date > $@

%.tgz: %.d
	tar czf $@ -C $< .

FORCE: ;

.PHONY: FORCE all images clean

=== tests/Makefile ===
#
# Copyright (C) 2012 Alexis Bienvenue <paamc@passoire.fr>
#
# This file is part of Auto-Multiple-Choice
#
# Auto-Multiple-Choice is free software: you can redistribute it
# and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# Auto-Multiple-Choice is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Auto-Multiple-Choice.  If not, see
# <http://www.gnu.org/licenses/>.

SHELL=/bin/sh

SVG=$(shell find . -name '*.svg')
EPS=$(SVG:.svg=.eps)

all: $(EPS)

%.eps: %.svg
	inkscape --export-eps $@ $<

clean:
	-rm $(EPS)

test: $(EPS)
	./all_tests

.PHONY: all clean test

=== doc/sty/Makefile ===
#
# Copyright (C) 2011 Alexis Bienvenue <paamc@passoire.fr>
#
# This file is part of Auto-Multiple-Choice
#
# Auto-Multiple-Choice is free software: you can redistribute it
# and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# Auto-Multiple-Choice is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Auto-Multiple-Choice.  If not, see
# <http://www.gnu.org/licenses/>.

SHELL=/bin/sh

PACK=automultiplechoice

all: FORCE
	pdflatex $(PACK).dtx
	pdflatex sample-amc.tex
	pdflatex sample-separate.tex
	pdflatex sample-plain.tex
	makeindex -s gglo.ist -o $(PACK).gls $(PACK).glo
	makeindex -s gind.ist -o $(PACK).ind $(PACK).idx
	pdflatex $(PACK).dtx
	pdflatex $(PACK).dtx
	$(MAKE) postclean

postclean:
	rm -f pexa-*
	rm -f $(foreach ext,amc aux dvi glo gls idx ilg ind log out toc xy xy1 xy2 xy3,*.$(ext))

clean: postclean
	rm -f *~
	rm -f $(PACK).sty
	rm -f *.pdf

FORCE: ;

.PHONY: all clean postclean FORCE

=== debian/changelog ===
auto-multiple-choice (1.2.1-1) unstable; urgency=low

  * New upstream release.

 -- Alexis Bienvenüe <pado@passoire.fr>  Thu, 01 Aug 2013 10:05:42 +0200

=== debian/control ===
Source: auto-multiple-choice
Section: education
Priority: optional
Maintainer: Alexis Bienvenüe <pado@passoire.fr>
Uploaders: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper (>= 9), gettext, libnetpbm10-dev,
 libxml-libxml-perl, dblatex, xsltproc, docbook-xml,
 docbook-xsl, librsvg2-bin, netpbm, libcv-dev (>=2.1), libhighgui-dev,
 latex-xcolor, tex-common, texlive-lang-french
Standards-Version: 3.9.4
Homepage: http://home.gna.org/auto-qcm/
Vcs-Browser: http://svn.gna.org/viewcvs/auto-qcm/
Vcs-Svn: svn://svn.gna.org/svn/auto-qcm/trunk

Package: auto-multiple-choice
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 auto-multiple-choice-common (= ${source:Version})
Recommends: auto-multiple-choice-doc (= ${source:Version})
Suggests: texstudio | texmaker | kile, openoffice.org-calc
Description: Auto Multiple Choice - multiple choice papers management
 Utility to manage multiple choice questionnaires, with optionally
 mixed questions and answers. AMC provides automatic marking from papers'
 scans. Annotated papers are produced. Marks can be exported as a
 OpenOffice.org sheet file.

Package: auto-multiple-choice-common
Architecture: all
Replaces: auto-multiple-choice (<< 1.1.0-1)
Breaks: auto-multiple-choice (<< 1.1.0-1)
Depends: ${misc:Depends}, ${perl:Depends},
 liblocale-gettext-perl, libxml-simple-perl, libxml-writer-perl,
 libgtk2-perl, libio-compress-perl|libcompress-zlib-perl,
 libgraphics-magick-perl, libdbd-sqlite3-perl, libdbi-perl,
 libfile-mimeinfo-perl, libtext-csv-perl, texlive-latex-base,
 latex-xcolor, texlive-generic-recommended, texlive-latex-extra,
 texlive-fonts-extra, imagemagick (>= 7:6.5.5) |
 graphicsmagick-imagemagick-compat, netpbm, ghostscript,
 poppler-utils, libarchive-zip-perl, librsvg2-common, unzip,
Recommends: libsys-cpu-perl, libnet-cups-perl (>= 0.60), 
 libopenoffice-oodoc-perl, libemail-mime-perl, libemail-sender-perl,
 fonts-linuxlibertine | ttf-linux-libertine, texlive-xetex,
 libgtk2-notify-perl
Description: Auto Multiple Choice - architecture independent files
 Utility to manage multiple choice questionnaires, with optionally
 mixed questions and answers. AMC provides automatic marking from papers'
 scans. Annotated papers are produced. Marks can be exported as a
 OpenOffice.org sheet file.
 .
 These are architecture independent files.

Package: auto-multiple-choice-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Auto Multiple Choice - HTML documentation
 Utility to manage multiple choice questionnaires, with optionally
 mixed questions and answers. AMC provides automatic marking from papers'
 scans. Annotated papers are produced. Marks can be exported as a
 OpenOffice.org sheet file.
 .
 This is AMC HTML documentation.

Package: auto-multiple-choice-doc-pdf
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Auto Multiple Choice - PDF documentation
 Utility to manage multiple choice questionnaires, with optionally
 mixed questions and answers. AMC provides automatic marking from papers'
 scans. Annotated papers are produced. Marks can be exported as a
 OpenOffice.org sheet file.
 .
 This is AMC PDF documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	SYSTEM_TYPE=deb dh $@ --with tex

override_dh_installtex:
	dh_installtex -pauto-multiple-choice-common

=== debian/watch ===
version=3

http://download.gna.org/auto-qcm/auto-multiple-choice_(.*)_sources\.tar\.gz

## auto-multiple-choice 1.3.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2008-2012 Alexis Bienvenue <paamc@passoire.fr>
+# Copyright (C) 2008-2016 Alexis Bienvenue <paamc@passoire.fr>
 #
 # This file is part of Auto-Multiple-Choice
 #
@@ -19,27 +19,19 @@
 
 # Loads separate configuration file
 
-ifeq ($(AMCCONF),)
-AMCCONFFILE ?= Makefile.conf
-else
-AMCCONFFILE = Makefile-$(AMCCONF).conf
-endif
-
-SUB_MAKEFILES=$(wildcard Makefile.versions $(AMCCONFFILE))
-
-include $(SUB_MAKEFILES)
-
-PACKAGE_DEB_DV=1
+include Makefile-all.conf
+
+PACKAGE_DEB_TARGET=unstable
 PERLPATH ?= /usr/bin/perl
 
 # DATE/TIME to be substituted
 
-DATE_RPMCHL:=$(shell LC_TIME=en_US date +"%a %b %e %Y")
-DATE_DEBCHL:=$(shell LANG=C date "+%a, %d %b %Y %H:%M:%S %z")
+DATE_RPMCHL:=$(shell LC_TIME=en date +"%a %b %e %Y")
+DATE_DEBCHL:=$(shell LANG=en date "+%a, %d %b %Y %H:%M:%S %z")
 
 # list variables to be substituted in *.in files
 
-SUBST_VARS:=$(shell grep -h '=' $(SUB_MAKEFILES) | perl -pe 's/\#.*//;s/\??\+?=.*//;' ) PACKAGE_DEB_DV PERLPATH DATE_DEBCHL DATE_RPMCHL
+SUBST_VARS:=$(sort $(shell grep -h '=' $(SUB_MAKEFILES) | perl -pe 's/\#.*//;s/\??\+?=.*//;' ) PACKAGE_DEB_DV PACKAGE_DEB_TARGET PERLPATH DATE_DEBCHL DATE_RPMCHL)
 
 # Some default values
 
@@ -51,22 +43,31 @@
 # try to find right names for OpenCV libs 
 
 ifeq ($(GCC_OPENCV_LIBS),auto)
-ifeq ($(shell echo 'main(){}' | gcc -xc -lopencv_core - -o /dev/null 2>/dev/null && echo "OK"),OK)
+ifeq ($(shell echo 'int main(){}' | gcc -xc -lopencv_core - && ( rm -f a.out ; echo "OK")),OK)
   GCC_OPENCV_LIBS:=-lopencv_core -lopencv_highgui -lopencv_imgproc
 else
   GCC_OPENCV_LIBS:=-lcv -lhighgui -lcxcore
 endif
 endif
 
+GCC_OPENCV ?= $(shell pkg-config --cflags opencv)
+GCC_OPENCV_LIBS ?= $(shell pkg-config --libs opencv)
+GCC_PDF ?= $(shell pkg-config --cflags --libs cairo pangocairo poppler-glib)
+
 #
 
 SHELL=/bin/sh
 
 DESTDIR=
 
+# debug...
+
+print-%: FORCE
+	@echo "$*=$($*)"
+
 # AMC components to build
 
-BINARIES ?= AMC-traitement-image AMC-detect
+BINARIES ?= AMC-detect AMC-buildpdf
 
 MODS=AMC-*.pl
 GLADE_FROMIN:=$(basename $(wildcard AMC-gui-*.glade.in))
@@ -82,7 +83,7 @@
 
 # list *.in files for @/VAR/@ substitution
 
-FROM_IN=auto-multiple-choice auto-multiple-choice.desktop $(GLADE_FROMIN) AMC-gui.pl AMC-latex-link.pl AMC-perl/AMC/Basic.pm doc/doc-xhtml-site.fr.xsl doc/doc-xhtml-site.en.xsl doc/doc-xhtml.xsl $(DOC_XML_IN:.in.xml=.xml) $(DTX)
+FROM_IN=auto-multiple-choice auto-multiple-choice.desktop $(GLADE_FROMIN) AMC-gui.pl AMC-latex-link.pl AMC-perl/AMC/Basic.pm doc/doc-xhtml-site.fr.xsl doc/doc-xhtml-site.ja.xsl doc/doc-xhtml-site.en.xsl doc/amcdocstyle.sty doc/doc-xhtml.xsl $(DOC_XML_IN:.in.xml=.xml) $(DTX)
 
 # Is this a precomp tarball? If so, the PRECOMP file is present.
 
@@ -105,9 +106,11 @@
 # Target switch (precomp archive or not)
 
 ifeq ($(PRECOMP_ARCHIVE),)
-all: $(FROM_IN) $(BINARIES) $(MAIN_LOGO).xpm doc I18N ;
-else
-all: all_precomp ;
+all: $(FROM_IN) $(BINARIES) $(MAIN_LOGO).xpm doc I18N
+	chmod a+x auto-multiple-choice
+else
+all: all_precomp
+	chmod a+x auto-multiple-choice
 endif
 
 all_precomp: $(FROM_IN) $(BINARIES) ;
@@ -115,20 +118,26 @@
 MAJ: $(FROM_IN) ;
 
 # Binaries
-
-AMC-traitement-image: AMC-traitement-image.c Makefile
-	$(GCC) -o $@ $< $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(GCC_NETPBM)
 
 AMC-detect: AMC-detect.cc Makefile
 	$(GCC_PP) -o $@ $< $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) $(CXXLDFLAGS) -lstdc++ -lm $(GCC_OPENCV) $(GCC_OPENCV_LIBS)
 
+AMC-buildpdf: AMC-buildpdf.cc buildpdf.cc Makefile
+	$(GCC_PP) -o $@ $< $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) $(CXXLDFLAGS) -lstdc++ -lm $(GCC_PDF) $(GCC_OPENCV) $(GCC_OPENCV_LIBS)
+
 # substitution in *.in files
 
-%.xml: %.in.xml
-	perl -p $(foreach varname,$(SUBST_VARS), -e 's|@/$(varname)/@|$($(varname))|g;' ) -e 's+/usr/share/xml/docbook/schema/dtd/4.5/docbookx.dtd+$(DOCBOOK_DTD)+g;' $< > $@
-
-%: %.in $(SUB_MAKEFILES)
-	perl -p $(foreach varname,$(SUBST_VARS), -e 's|@/$(varname)/@|$($(varname))|g;' ) $< > $@
+vars-subs.pl: $(SUB_MAKEFILES)
+	@echo "Recording substitution variables from $(SUB_MAKEFILES)"
+	@echo "# Variables:" > $@
+	@$(foreach varname,$(SUBST_VARS), echo 's|@/$(varname)/@|$($(varname))|g;' >> $@ ; )
+	@echo 's+/usr/share/xml/docbook/schema/dtd/4.5/docbookx.dtd+$(DOCBOOK_DTD)+g;' >> $@
+
+%.xml: %.in.xml vars-subs.pl 
+	perl -p vars-subs.pl $< > $@
+
+%: %.in vars-subs.pl
+	perl -p vars-subs.pl $< > $@
 
 # some components
 
@@ -160,11 +169,13 @@
 
 clean_IN: FORCE
 	rm -rf debian/auto-multiple-choice
+	rm -f local/deb-auto-changelog
 	rm -f $(FROM_IN)
 
 clean: clean_IN FORCE
-	rm -f $(BINARIES) $(MAIN_LOGO).xpm
-	rm -f auto-multiple-choice.spec
+	-rm -f $(BINARIES) $(MAIN_LOGO).xpm
+	-rm -f auto-multiple-choice.spec
+	-rm -f vars-subs.pl
 	$(MAKE) -C doc/sty clean
 	$(MAKE) -C doc clean
 	$(MAKE) -C I18N clean
@@ -179,12 +190,12 @@
 
 install_models_%: FORCE
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(MODELSDIR)/$*
-	install    -m 0644 $(USER_GROUP) doc/modeles/$*/*.tgz $(DESTDIR)/$(MODELSDIR)/$*
-	install    -m 0644 $(USER_GROUP) doc/modeles/$*/*.xml $(DESTDIR)/$(MODELSDIR)/$*
+	-install    -m 0644 $(USER_GROUP) doc/modeles/$*/*.tgz $(DESTDIR)/$(MODELSDIR)/$*
+	-install    -m 0644 $(USER_GROUP) doc/modeles/$*/*.xml $(DESTDIR)/$(MODELSDIR)/$*
 
 install_models: $(addprefix install_models_,$(SUBMODS)) ;
 
-install: install_lang install_models FORCE
+install_nodoc: install_lang install_models FORCE
 ifneq ($(SYSTEM_TYPE),deb) # with debian, done with dh_installmime
 ifneq ($(SHARED_MIMEINFO_DIR),)
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(SHARED_MIMEINFO_DIR)
@@ -203,10 +214,6 @@
 	install    -m 0644 $(USER_GROUP) $(GLADE) $(DESTDIR)/$(MODSDIR)/perl
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(TEXDIR)
 	install    -m 0644 $(USER_GROUP) $(STY) $(DESTDIR)/$(TEXDIR)
-ifneq ($(TEXDOCDIR),)
-	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(TEXDOCDIR)
-	install    -m 0644 $(USER_GROUP) doc/sty/*.pdf doc/sty/*.tex $(DESTDIR)/$(TEXDOCDIR)
-endif
 ifneq ($(DESKTOPDIR),)
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(DESKTOPDIR)
 	install    -m 0644 $(USER_GROUP) -T auto-multiple-choice.desktop $(DESTDIR)/$(DESKTOPDIR)/auto-multiple-choice.desktop
@@ -226,6 +233,7 @@
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Filter/register
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/DataModule
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Gui
+	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(PERLDIR)/AMC/Print
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/*.pm $(DESTDIR)/$(PERLDIR)/AMC
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Export/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Export
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Export/register/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Export/register
@@ -234,6 +242,14 @@
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/DataModule/*.pm $(DESTDIR)/$(PERLDIR)/AMC/DataModule
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Gui/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Gui
 	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Gui/*.glade $(DESTDIR)/$(PERLDIR)/AMC/Gui
+	install    -m 0644 $(USER_GROUP) AMC-perl/AMC/Print/*.pm $(DESTDIR)/$(PERLDIR)/AMC/Print
+
+install_doc: FORCE
+	@echo "Installing doc..."
+ifneq ($(TEXDOCDIR),)
+	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(TEXDOCDIR)
+	install    -m 0644 $(USER_GROUP) doc/sty/*.pdf doc/sty/*.tex $(DESTDIR)/$(TEXDOCDIR)
+endif
 ifneq ($(SYSTEM_TYPE),deb) # with debian, done with dh_install{doc,man}
 	install -d -m 0755 $(USER_GROUP) $(DESTDIR)/$(DOCDIR)
 	install    -m 0644 $(USER_GROUP) $(wildcard doc/auto-multiple-choice.??.xml doc/auto-multiple-choice.??.pdf) $(DESTDIR)/$(DOCDIR)
@@ -250,6 +266,8 @@
 	install    -m 0644 $(USER_GROUP) doc/*.1 $(DESTDIR)/$(MAN1DIR)
 endif
 
+install: install_nodoc install_doc ;
+
 # Test
 
 manual-test:
@@ -264,7 +282,7 @@
 
 global: FORCE
 	$(MAKE) -C I18N global LOCALEDIR=$(LOCALEDIR) LOCALDIR=$(LOCALDIR)
-	-sudo rm /usr/share/perl5/AMC $(ICONSDIR) /usr/share/doc/auto-multiple-choice /usr/share/doc/auto-multiple-choice-doc $(LOCALEDIR)/fr/LC_MESSAGES/auto-multiple-choice.mo $(DESKTOPDIR)/auto-multiple-choice.desktop $(MODELSDIR) /usr/bin/auto-multiple-choice $(TEXDIR)/automultiplechoice.sty
+	-sudo rm /usr/share/perl5/AMC $(ICONSDIR) /usr/share/doc/auto-multiple-choice /usr/share/doc/auto-multiple-choice-doc $(LOCALEDIR)/fr/LC_MESSAGES/auto-multiple-choice.mo $(DESKTOPDIR)/auto-multiple-choice.desktop $(MODELSDIR) /usr/bin/auto-multiple-choice $(TEXDIR)/automultiplechoice.sty $(SHARED_MIMEINFO_DIR)/auto-multiple-choice.xml $(LANG_GTKSOURCEVIEW_DIR)/amc-txt.lang
 	-sudo rm -r /usr/lib/AMC
 
 local: global
@@ -275,8 +293,8 @@
 	test -d /usr/share/auto-multiple-choice  || sudo mkdir -p /usr/share/auto-multiple-choice
 	test -d $(TEXDIR) || sudo mkdir $(TEXDIR)
 	sudo ln -s $(LOCALDIR)/AMC-perl/AMC /usr/share/perl5/AMC
-	sudo ln -s $(LOCALDIR)/AMC-traitement-image /usr/lib/AMC/exec/AMC-traitement-image
 	sudo ln -s $(LOCALDIR)/AMC-detect /usr/lib/AMC/exec/AMC-detect
+	sudo ln -s $(LOCALDIR)/AMC-buildpdf /usr/lib/AMC/exec/AMC-buildpdf
 	sudo ln -s $(LOCALDIR)/AMC-*.pl $(LOCALDIR)/AMC-*.glade /usr/lib/AMC/perl
 	sudo ln -s $(LOCALDIR)/auto-multiple-choice /usr/bin
 	sudo ln -s $(LOCALDIR)/icons $(ICONSDIR)
@@ -284,6 +302,8 @@
 	sudo ln -s $(LOCALDIR)/auto-multiple-choice.desktop $(DESKTOPDIR)/auto-multiple-choice.desktop
 	sudo ln -s $(LOCALDIR)/doc/modeles $(MODELSDIR)
 	sudo ln -s $(LOCALDIR)/$(STY) $(TEXDIR)/automultiplechoice.sty
+	sudo ln -s $(LOCALDIR)/interfaces/amc-txt.lang $(LANG_GTKSOURCEVIEW_DIR)
+	sudo ln -s $(LOCALDIR)/interfaces/auto-multiple-choice.xml $(SHARED_MIMEINFO_DIR)
 
 ifdef DEBSIGN_KEY
 DEBSIGN=-k$(DEBSIGN_KEY)
@@ -296,8 +316,9 @@
 TMP_DIR=/tmp
 SOURCE_DIR=auto-multiple-choice-$(PACKAGE_V_DEB)
 TMP_SOURCE_DIR=$(TMP_DIR)/$(SOURCE_DIR)
-
-SRC_EXCL=--exclude debian '--exclude=*~' 
+ORIG_SOURCES=/tmp/auto-multiple-choice_$(PACKAGE_V_DEB).orig.tar.gz
+
+SRC_EXCL=--exclude debian '--exclude=*~' --exclude .hgignore --exclude .hgtags
 
 version_files:
 	perl local/versions.pl
@@ -311,26 +332,3 @@
 
 portable_vok:
 	$(eval TMP_PORTABLE:=$(shell mktemp -d /tmp/portable.XXXXXXXXXX))
-	$(MAKE) tmp_copy
-	make AMCCONF=portable INSTREP=$(TMP_PORTABLE)/AMC -C $(TMP_SOURCE_DIR)
-	make AMCCONF=portable INSTREP=$(TMP_PORTABLE)/AMC -C $(TMP_SOURCE_DIR) install
-	cd $(TMP_PORTABLE) ; tar cvzf /tmp/auto-multiple-choice_$(PACKAGE_V_DEB)_portable.tar.gz $(SRC_EXCL) AMC
-	rm -rf $(TMP_PORTABLE)
-
-sources_vok:
-	$(MAKE) tmp_copy
-	cd /tmp ; tar cvzf auto-multiple-choice_$(PACKAGE_V_DEB)_sources.tar.gz $(SRC_EXCL) $(SOURCE_DIR)
-	$(MAKE) -C $(TMP_SOURCE_DIR) MAJ
-	$(MAKE) -C $(TMP_SOURCE_DIR) $(MAIN_LOGO).xpm I18N doc
-	$(MAKE) -C $(TMP_SOURCE_DIR) clean_IN
-	$(MAKE) -C $(TMP_SOURCE_DIR) auto-multiple-choice.spec
-	touch $(TMP_SOURCE_DIR)/$(PRECOMP_FLAG_FILE)
-	test -d ../precomp_external && cp -r ../precomp_external/* $(TMP_SOURCE_DIR)
-	cd /tmp ; tar cvzf auto-multiple-choice_$(PACKAGE_V_DEB)_precomp.tar.gz $(SRC_EXCL) $(SOURCE_DIR)
-
-tmp_deb:
-	$(MAKE) local/deb-auto-changelog
-	$(MAKE) tmp_copy
-	cp local/deb-auto-changelog $(TMP_SOURCE_DIR)/debian/changelog
-
-debsrc_vok: tmp_deb

=== I18N/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2010-2012 Alexis Bienvenue <paamc@passoire.fr>
+# Copyright (C) 2010-2016 Alexis Bienvenue <paamc@passoire.fr>
 #
 # This file is part of Auto-Multiple-Choice
 #
@@ -55,7 +55,7 @@
 
 $(DOMAIN).bpot: $(PERL) $(GLADE)
 	xgettext $(XGETTO) --from-code=UTF-8 --add-comments=TRANSLATORS: $(PERL) -k__ -k__p -k -o $@
-	xgettext $(XGETTO) -j $(GLADE) -o $@
+	xgettext $(XGETTO) -j $(GLADE) -L Glade -o $@
 
 list:
 	grep -lr __ $(AMC) |grep '\.\(pl\|pm\)$$' | grep -v 'debian' ; ls $(GLADE)

=== doc/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2008-2010,2012 Alexis Bienvenue <paamc@passoire.fr>
+# Copyright (C) 2008-2016 Alexis Bienvenue <paamc@passoire.fr>
 #
 # This file is part of Auto-Multiple-Choice
 #
@@ -19,15 +19,21 @@
 
 SHELL=/bin/sh
 
-include ../Makefile.conf
+include ../Makefile-all.conf
 
-DOCBOOKS=$(filter-out $(wildcard *.in.xml),$(wildcard *.xml))
+ALL_DOCBOOKS = $(filter-out $(wildcard *.in.xml),$(wildcard auto-multiple-choice.*.xml))
+DOC_LANG ?= $(patsubst auto-multiple-choice.%.xml,%,$(ALL_DOCBOOKS))
+SELECTED_DOCBOOKS = $(foreach onelang,$(DOC_LANG),auto-multiple-choice.$(onelang).xml)
 
 IMAGES=$(addprefix html/images/,$(notdir $(wildcard img_src/*.svg))) $(addprefix html/images/callouts/,$(notdir $(wildcard img_src/callouts/*.svg)))
+BLOCK_IMAGES=$(addprefix img_pdf/,$(notdir $(wildcard img_src/*.svg)))
 
 MODELS=$(wildcard modeles/*/*.d)
 
-all: $(filter-out %.ja.pdf,$(DOCBOOKS:.xml=.pdf)) $(DOCBOOKS:.xml=.x) $(IMAGES:.svg=.png) $(MODELS:.d=.tgz) html/index.html;
+all: $(SELECTED_DOCBOOKS:.xml=.pdf) $(SELECTED_DOCBOOKS:.xml=.x) $(IMAGES:.svg=.png) $(MODELS:.d=.tgz) html/index.html;
+
+show_doc_lang:
+	@echo "DOC_LANG = $(DOC_LANG)"
 
 images: $(IMAGES:.svg=.png)
 
@@ -36,7 +42,7 @@
 	rm -f modeles/*.tgz
 	rm -f modeles/**/*.tgz
 	rm -f html/auto-multiple-choice.**/*.html
-	rm -f html/images/callouts/*.png html/images/*.png
+	rm -f html/images/callouts/*.png html/images/*.png img_pdf/*.pdf
 	rm -f *~
 
 html/images/callouts/%.png: img_src/callouts/%.svg
@@ -45,17 +51,29 @@
 html/images/%.png: img_src/%.svg
 	rsvg-convert -w 24 -h 24 $< -o $@
 
+img_pdf/%.pdf: img_src/%.svg
+	rsvg-convert -f pdf $< -o $@
+
 html/index.html: FORCE
 	./index.pl $(DOCBOOKS:.xml=) > $@
 
-%.tex: %.xml
-	dblatex -t tex --xslt-opts="--nonet" --xslt-opts="--catalogs" $(DBLATEX_OPT) $< -o $@
-	perl addlink.pl $@
+%.tex: %.xml amcdocstyle.sty
+	 case $< in \
+	   *.ja.xml) dblatex -P latex.encoding=utf8 -b xetex -t tex -p custom.xsl --texstyle=amcdocstyle --xslt-opts="--nonet" --xslt-opts="--catalogs" $(DBLATEX_OPT) $< -o $@ ;; \
+	   *.xml) dblatex -t tex -p custom.xsl --texstyle=amcdocstyle --xslt-opts="--nonet" --xslt-opts="--catalogs" $(DBLATEX_OPT) $< -o $@ ;; \
+	 esac
 
-%.pdf: %.tex
-	case $< in \
-	  *.ja.tex) platex $<; platex $<; dvipdf $*.dvi ;; \
-	  *.tex) pdflatex $<; pdflatex $< ;; \
+%.pdf: %.tex $(BLOCK_IMAGES:.svg=.pdf)
+	export TEXINPUTS=./img_pdf/: ; case $< in \
+	  *.ja.tex) \
+            sed -i -e '/setuplocale/a\
+\\usepackage{xeCJK}\
+\\setCJKmainfont{IPAexMincho}\
+\\setCJKsansfont{IPAexGothic}\
+\\setCJKmonofont{IPAexGothic}\
+' $<; \
+            xelatex $<; xelatex $<; ../reproducible-pdf.pl --fonts --id $@ ;; \
+	  *.tex) pdflatex $<; pdflatex $<; ../reproducible-pdf.pl --id $@ ;; \
 	esac
 	rm -f $(foreach ext,aux cb cb2 glo idx log out toc,$*.$(ext))
 
@@ -75,7 +93,9 @@
 	date > $@
 
 %.tgz: %.d
-	tar czf $@ -C $< .
+	find $< -type d -exec chmod 0755 '{}' \;
+	find $< -type f -exec chmod 0644 '{}' \;
+	tar cn -C $< $(TAR_REPRODUCIBLE_ARGS) -O . | gzip $(GZIP_REPRODUCIBLE_ARGS) -c > $@
 
 FORCE: ;

=== doc/sty/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011 Alexis Bienvenue <paamc@passoire.fr>
+# Copyright (C) 2011-2016 Alexis Bienvenue <paamc@passoire.fr>
 #
 # This file is part of Auto-Multiple-Choice
 #
@@ -21,20 +21,32 @@
 
 PACK=automultiplechoice
 
+SAMPLES=$(wildcard sample-*.tex)
+
 all: FORCE
 	pdflatex $(PACK).dtx
-	pdflatex sample-amc.tex
-	pdflatex sample-separate.tex
-	pdflatex sample-plain.tex
+	$(MAKE) $(SAMPLES:.tex=.pdf)
+	pdflatex $(PACK).dtx
 	makeindex -s gglo.ist -o $(PACK).gls $(PACK).glo
 	makeindex -s gind.ist -o $(PACK).ind $(PACK).idx
 	pdflatex $(PACK).dtx
 	pdflatex $(PACK).dtx
+	../../reproducible-pdf.pl --id $(PACK).pdf
 	$(MAKE) postclean
 
+sample-%.datetex.in: sample-%.tex
+	perl -pe 's!\\begin\{document\}!\\begin{document}\\pdfinfo{/CreationDate (D:@/PACKAGE_V_PDFDATE/@) /ModDate (D:@/PACKAGE_V_PDFDATE/@)}!;' < $< > $@
+
+sample-%.datetex: sample-%.datetex.in
+	$(MAKE) -C ../.. doc/sty/$@
+
+sample-%.pdf: sample-%.datetex
+	pdflatex -jobname sample-$* $<
+	../../reproducible-pdf.pl --id $@
+
 postclean:
-	rm -f pexa-*
-	rm -f $(foreach ext,amc aux dvi glo gls idx ilg ind log out toc xy xy1 xy2 xy3,*.$(ext))
+	-rm -f pexa-*
+	-rm -f $(foreach ext,amc aux dvi glo gls idx ilg ind log out toc xy xy1 xy2 xy3,*.$(ext))
 
 clean: postclean
 	rm -f *~

=== debian/changelog ===
auto-multiple-choice (1.3.0-2) unstable; urgency=medium

  * Updates watch file to version 4, with signature check.
  * Adds patches from development version:
    - bugfix-412: Fix for bug #412
    - tests-INC-fix: Fix for tests with recent perl
  * Adds fix-build-with-opencv-3.1 to fix FTBS with OpenCV 3.1,
    thanks to Nobuhiro Iwamatsu; Closes: #841244
  * Reproducible file ordering in models tar archives.
  * Bumps Standards-Version to 3.9.8.0.

 -- Alexis Bienvenüe <pado@passoire.fr>  Thu, 20 Oct 2016 08:47:56 +0200

auto-multiple-choice (1.3.0-1) unstable; urgency=medium

  * New upstream release. Closes: #784088
  * Drops patches clang-ftbfs and reproducible, which has been merged upstream.
  * Updates dependencies.
  * Removes menu file, as there is a desktop file (see CTTE #741573).
  * Bumped Standards-Version to 3.9.7.0.
  * Adds installation test with Autopkgtest.
  * New mercurial upstream repository.
  * Moves desktop file to auto-multiple-choice package, which is the main
    one to be installed to get the "application".
    
 -- Alexis Bienvenüe <pado@passoire.fr>  Wed, 16 Mar 2016 10:12:03 +0100

auto-multiple-choice (1.2.1-4) unstable; urgency=medium

  * applied the recipe found at
    https://wiki.debian.org/ReproducibleBuilds/UsersAndGroupsInTarballs
    which should allow a reproducible build.

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 02 Mar 2016 17:32:15 +0100

auto-multiple-choice (1.2.1-3) unstable; urgency=medium

  * Use right directory for LaTeX doc; Closes: #766286
  * Bumped Standards-Version to 3.9.6.0.

 -- Alexis Bienvenüe <pado@passoire.fr>  Thu, 23 Oct 2014 16:02:55 +0200

auto-multiple-choice (1.2.1-2) unstable; urgency=low

  * [Arthur Marble] Fix FTBFS with clang; Closes: #746196
    - Fixed the Function definition is not allowed here error in
      AMC-traitement-image.c: refactored code so functions can be
      properly defined
  
  * [Alexis Bienvenüe] Bumped Standards-Version to 3.9.5.

 -- Alexis Bienvenüe <pado@passoire.fr>  Thu, 01 May 2014 21:26:06 +0200

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,23 @@
 Uploaders: Georges Khaznadar <georgesk@debian.org>
 Build-Depends: debhelper (>= 9), gettext, libnetpbm10-dev,
  libxml-libxml-perl, dblatex, xsltproc, docbook-xml,
- docbook-xsl, librsvg2-bin, netpbm, libcv-dev (>=2.1), libhighgui-dev,
- latex-xcolor, tex-common, texlive-lang-french
-Standards-Version: 3.9.4
+ docbook-xsl, librsvg2-bin, netpbm, pgf,
+ pkg-config, libopencv-dev (>=2.1),
+ libpoppler-glib-dev, libcairo2-dev, libpango1.0-dev,
+ latex-xcolor, texlive-xetex, lmodern, pdftk,
+ texlive-lang-french, texlive-lang-japanese
+Standards-Version: 3.9.8.0
 Homepage: http://home.gna.org/auto-qcm/
-Vcs-Browser: http://svn.gna.org/viewcvs/auto-qcm/
-Vcs-Svn: svn://svn.gna.org/svn/auto-qcm/trunk
+Vcs-Browser: https://bitbucket.org/auto-multiple-choice/auto-multiple-choice/src
+Vcs-Hg: https://bitbucket.org/auto-multiple-choice/auto-multiple-choice
+Testsuite: autopkgtest
 
 Package: auto-multiple-choice
 Architecture: any
+Replaces: auto-multiple-choice-common (<< 1.3.0-1)
+Breaks: auto-multiple-choice-common (<< 1.3.0-1)
 Depends: ${misc:Depends}, ${shlibs:Depends},
- auto-multiple-choice-common (= ${source:Version})
+ perl, auto-multiple-choice-common (= ${source:Version})
 Recommends: auto-multiple-choice-doc (= ${source:Version})
 Suggests: texstudio | texmaker | kile, openoffice.org-calc
 Description: Auto Multiple Choice - multiple choice papers management
@@ -34,9 +40,11 @@
  libgraphics-magick-perl, libdbd-sqlite3-perl, libdbi-perl,
  libfile-mimeinfo-perl, libtext-csv-perl, texlive-latex-base,
  latex-xcolor, texlive-generic-recommended, texlive-latex-extra,
- texlive-fonts-extra, imagemagick (>= 7:6.5.5) |
- graphicsmagick-imagemagick-compat, netpbm, ghostscript,
+ texlive-fonts-recommended, texlive-fonts-extra,
+ imagemagick (>= 7:6.5.5) | graphicsmagick-imagemagick-compat,
+ netpbm, ghostscript,
  poppler-utils, libarchive-zip-perl, librsvg2-common, unzip,
+ libglib-object-introspection-perl
 Recommends: libsys-cpu-perl, libnet-cups-perl (>= 0.60), 
  libopenoffice-oodoc-perl, libemail-mime-perl, libemail-sender-perl,
  fonts-linuxlibertine | ttf-linux-libertine, texlive-xetex,

=== debian/tests/control ===
Tests: simple
Depends: @, libipc-run-perl

Tests: gui
Depends: @, xvfb

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/$/.sig/" http://download.gna.org/auto-qcm/auto-multiple-choice_(.*)_sources\.tar\.gz

## auto-multiple-choice 1.4.0~rc1

=== debian/changelog ===
auto-multiple-choice (1.4.0~rc1-2) unstable; urgency=medium

  [ Alexis Bienvenüe ]
  * GUI test: depend on at-spi2-core to avoid warnings on stderr,
    thanks to Paul Gevers. Closes: #903699.

 -- Alexis Bienvenüe <pado@passoire.fr>  Sat, 14 Jul 2018 19:22:56 +0200

auto-multiple-choice (1.4.0~rc1-1) unstable; urgency=medium

  [ Alexis Bienvenüe ]
  * New upstream version 1.4.0~rc1. Closes: #902655.
  * Updates dependencies for new upstream version.
  * Removes all patches now included upstream.
  * Removes the Testsuite entry in d/control, see
    https://lintian.debian.org/tags/unnecessary-testsuite-autopkgtest-field.html
  * Adds a dependency on liblocale-codes-perl. Closes: #903254.
  * Bumps Standards-Version to 4.1.5.0, no change needed.

  [ Georges Khaznadar ]
  * rebuilt and signed

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 09 Jul 2018 09:44:44 +0200

auto-multiple-choice (1.3.0-5) unstable; urgency=medium

  [ Alexis Bienvenüe ]
  * Fix FTBFS with TL2018, using \UseRawInputEncoding.
    Closes: #896948
    
  [ Georges Khaznadar ]
  * moved all patches under debian/patches, refreshed the patch
    latex-docstrip-raw-encoding.diff
  * modified Vcs stuff in debian/controll, to point to salsa.debian.org

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 29 Apr 2018 12:55:44 +0200

auto-multiple-choice (1.3.0-4) unstable; urgency=medium

  * Corrects obsolete perl syntax for use with perl 5.26,
    thanks to Steve Langasek; Closes: #870129

 -- Alexis Bienvenüe <pado@passoire.fr>  Tue, 08 Aug 2017 21:20:06 +0200

auto-multiple-choice (1.3.0-3) unstable; urgency=medium

  * Updates dependency on dropped packages latex-xcolor and pgf;
    Closes: #865233
  * Updates download URL.

 -- Alexis Bienvenüe <pado@passoire.fr>  Tue, 20 Jun 2017 23:18:05 +0200

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
 Uploaders: Georges Khaznadar <georgesk@debian.org>
 Build-Depends: debhelper (>= 9), gettext, libnetpbm10-dev,
  libxml-libxml-perl, dblatex, xsltproc, docbook-xml,
- docbook-xsl, librsvg2-bin, netpbm, pgf,
+ docbook-xsl, librsvg2-bin, netpbm, texlive-pictures,
  pkg-config, libopencv-dev (>=2.1),
  libpoppler-glib-dev, libcairo2-dev, libpango1.0-dev,
- latex-xcolor, texlive-xetex, lmodern, pdftk,
+ texlive-latex-recommended, texlive-xetex, lmodern,
  texlive-lang-french, texlive-lang-japanese
-Standards-Version: 3.9.8.0
-Homepage: http://home.gna.org/auto-qcm/
-Vcs-Browser: https://bitbucket.org/auto-multiple-choice/auto-multiple-choice/src
-Vcs-Hg: https://bitbucket.org/auto-multiple-choice/auto-multiple-choice
-Testsuite: autopkgtest
+Standards-Version: 4.1.5.0
+Homepage: http://www.auto-multiple-choice.net/
+Vcs-Browser: https://salsa.debian.org/georgesk/auto-multiple-choice
+Vcs-Git: https://salsa.debian.org/georgesk/auto-multiple-choice.git
 
 Package: auto-multiple-choice
 Architecture: any
@@ -36,19 +35,20 @@
 Breaks: auto-multiple-choice (<< 1.1.0-1)
 Depends: ${misc:Depends}, ${perl:Depends},
  liblocale-gettext-perl, libxml-simple-perl, libxml-writer-perl,
- libgtk2-perl, libio-compress-perl|libcompress-zlib-perl,
+ libgtk3-perl, libio-compress-perl|libcompress-zlib-perl,
  libgraphics-magick-perl, libdbd-sqlite3-perl, libdbi-perl,
+ liblocale-codes-perl,
  libfile-mimeinfo-perl, libtext-csv-perl, texlive-latex-base,
- latex-xcolor, texlive-generic-recommended, texlive-latex-extra,
+ texlive-latex-recommended, texlive-generic-recommended, texlive-latex-extra,
  texlive-fonts-recommended, texlive-fonts-extra,
  imagemagick (>= 7:6.5.5) | graphicsmagick-imagemagick-compat,
  netpbm, ghostscript,
  poppler-utils, libarchive-zip-perl, librsvg2-common, unzip,
- libglib-object-introspection-perl
+ libglib-object-introspection-perl, libclone-perl
 Recommends: libsys-cpu-perl, libnet-cups-perl (>= 0.60), 
  libopenoffice-oodoc-perl, libemail-mime-perl, libemail-sender-perl,
  fonts-linuxlibertine | ttf-linux-libertine, texlive-xetex,
- libgtk2-notify-perl
+ libfilesys-df-perl, qpdf | pdftk
 Description: Auto Multiple Choice - architecture independent files
  Utility to manage multiple choice questionnaires, with optionally
  mixed questions and answers. AMC provides automatic marking from papers'
